/* -*- mode: c++; c-basic-offset: 4; indent-tabs-mode: nil -*-

   this file is part of rcssserver3D
   Fri May 9 2003
   Copyright (C) 2002,2003 Koblenz University
   Copyright (C) 2003 RoboCup Soccer Server 3D Maintenance Group
   $Id: rendernode.cpp 207 2010-06-01 13:04:58Z sgvandijk $

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   RenderNode
*/
#include "rendernode.h"

using namespace kerosin;
using namespace std;

RenderNode::RenderNode()
    : BaseNode(),
      mTransparent(false),
      mVisible(true),
      mVisibleToggled(true)
{
}

RenderNode::~RenderNode()
{
}

void RenderNode::SetTransparent()
{
    mTransparent = true;
}

void RenderNode::SetVisible(bool visible)
{
    if (!mVisibleToggled && mVisible != visible)
      mVisibleToggled = true;
    mVisible = visible;
}

bool RenderNode::VisibleToggled()
{
    bool tmp = mVisibleToggled;
    mVisibleToggled = false;
    return tmp;
}
